#ifndef _EVAL
#define _EVAL
#include "utils2.h"
#include "ecommon.h"

struct Socket2 {
 bool log;
 SArray2<RowLock> rowlocks;
 _int64 mid; //machine id
 StringDataArray sfields,svalues; //TCP/IP session state
 unsigned long localport,localip;
 SOCKADDR_IN peersa;//also used for udp (remoteip)
 Socket2() {
  log=false;
 }
};

typedef void (CALLBACK * DLLIDLE)(bool turnaround);
typedef void (CALLBACK * DLLUNLOAD)(); //SArray<void *> & adjs,SArray<void *> & validate);
typedef void (CALLBACK * DLLINIT)(const char * dbname);
typedef void (CALLBACK * DLLONCLOSE)(const char * dbname,bool stchange=false);
typedef bool (CALLBACK * DLLWEBPROC)(StringData & proc,SDA & fields,SDA & values,StringData & result,SDA & cfields,SDA & cvalues,StringData & ct,StringData & cd,Socket2 & s); //unsigned long ip,SDA & sfields,SDA & svalues);
typedef bool (CALLBACK * DLLPROC)(StringData & proc,IDatabase * db,SArray<bbaserst*> & rts,SDA & fields,SDA & values,StringData & errorstr,Socket2 & s); //unsigned long remoteip,unsigned long localport,unsigned long localip,SDA & sfields,SDA & svalues);
typedef char (CALLBACK * DLLVALIDATECONNECT)(char type,Socket2 & s);
typedef char (CALLBACK * DLLVALIDATEOPEN)(StringData & dbname,StringData & suser,StringData & spwd,StringData & pwd,bool & readonly,bool validate,Socket2 & s);
typedef char (CALLBACK * DLLVALIDATECREATE)(StringData & dbname,StringData & suser,StringData & spwd,StringData & pwd,bool validate,Socket2 & s);
typedef char (CALLBACK * DLLVALIDATEFILELIST)(StringData & fn,IDatabase * db,Socket2 & s);
typedef char (CALLBACK * DLLVALIDATEFILESAVE)(StringData & fn,IDatabase * db,Socket2 & s,long size);
typedef char (CALLBACK * DLLVALIDATEFILEGET)(StringData & fn,IDatabase * db,Socket2 & s);

struct DLL {
private:
 DLL(DLL & ) {
  MMsgbox("err");
 }
public:
 StringData fn;
 HMODULE h;
 DLLIDLE onidle;
 DLLUNLOAD onunload;
 DLLINIT onopen;
 DLLONCLOSE onclose;
 DLLWEBPROC webproc;
 DLLVALIDATECONNECT validateconnect;
 DLLVALIDATEOPEN validateopen;
 DLLVALIDATECREATE validatecreate;
 DLLVALIDATEFILELIST validatefilelist;
 DLLVALIDATEFILESAVE validatefilesave;
 DLLVALIDATEFILEGET validatefileget;
 DLLPROC proc;
 bool unloaded;
void operator =(DLL & d) {
  fn=d.fn;
  h=d.h;
  onidle=d.onidle;
  onunload=d.onunload;
  onopen=d.onopen;
  onclose=d.onclose;
  webproc=d.webproc;
  validateconnect=d.validateconnect;
  validateopen=d.validateopen;
  validatecreate=d.validatecreate;
  validatefilelist=d.validatefilelist;
  validatefilesave=d.validatefilesave;
  validatefileget=d.validatefileget;
  proc=d.proc;
  unloaded=d.unloaded;
 }
 void init() {
  unloaded=false;
  //fn.init();
 }
 DLL() {
  init();
 }
};

void loaddlls(SDA d,SArray2<DLL> & dlls);
void getsettings(const char * fn,SArray<unsigned long> & mainports,SDA & dlls,long & maxsocks,long & maxdbs,SD & stunnel);
class Eval;
struct token {
private:
 token(token & ) {
  MMsgbox("err");
 }
public:
 //DED void setttype(); //sets the type of the token based on its sval's dt
 //DED void setsdtype(); //sets the dt of the sval based on the token's type
 int trueskip,falseskip;
	char optype; //operator type
	//char type; //operand type
	StringData sval;
 void dump() {
  SD s;
  if (optype==0) {
   s="type=";
   s+=str(sval.dt);
   s+="; value=";
   //setsdtype();
   s+=sval.asstring();
  } else {
   s="optype=";s+=optype;
  }
  s+='\n';
  ::OutputDebugStringA(s);
 }
 //union {
	 //double dval;
	 //long lval;
 //};
 bool sheetgiven; //applicable only if fpos (sheetid)>0
	signed long fpos; //also acts as sheetid
 unsigned char dt;
 long sr,sc,er,ec; //,fpos,dt,trueskip,falseskip;
 bool srfixed,scfixed,erfixed,ecfixed;
	//StringData sd;
	DED token() {
		optype=0;
		//type=0;
		//fpos=255;
		//dt=0;
		//trueskip=0;
		//falseskip=0;
	}
 DED void operator =(StringData & sd);
 DED bool operator ==(token & b );
	DED void operator =(token & Src );
	DED void operator =(token * Src ) {
 (*this)=(*Src);
	}
};


typedef bool (CALLBACK * EVALCBV) (Eval * e,void * p,token * t,token * newt);
typedef bool (CALLBACK * EVALCBF) (Eval * e,void * p,token * f,Stack<token *> & st,token * newt);

class Eval {
private:
 Eval(Eval& e) {
  MMsgbox("err");
 }
public:
 void operator =(Eval & e);
 StringData formula; //tosave the original formula,may be setted bu the call for future reference
 DED void remove(int pos,int cound);
 DED int skipfill(int pos,int &removed);
 DED void Eval::unskipfill();
 DED void Eval::skipfill();
 DED StringData buildstr(int pos,char what=0);
 DED StringData buildstrold(int pos,char what=0);
 DED StringData buildstr();
 Stack<token *> st;Stack<token *> st2;
 //Stack st,st2;
 DED int getandor(int pos,SDWordArray & apos,SDWordArray &asize,SDWordArray &trueskip,SDWordArray &falseskip,SByteArray & optype,SDWordArray & opsize);
 DED void rejoinands(SDWordArray & apos,SDWordArray &asize);
 DED int sameandor(int pos);
 //DED static COleVariant ttov(token *a,unsigned char dt);
 DED static StringData errorstr;
 DED static StringData ttosd(token *a,unsigned char dt);
 //DED static void ttov(token *t,unsigned char dt,COleVariant &v);
 DED static void ttosd(token *t,unsigned char dt,StringData &sd);
 DED static bool isliteral(token * t);
 //DED static void todouble(token * t);
 DED static void tolonglong(token * t);
	DED static void tolong(token * t);
	DED static void todbl(token * t);
	DED static void tostr(token * t);
 DED static void tostr2(token * t);
 DED static SD quote(const char * buf);
	DED void evalop(token *a,token *b,token *op,token *nnew);
	DED void evalop(token *a,token *op,token *nnew);
	DED void freealltokens(token * except);
	DED token * getnewtoken();
 DED int getsize(int pos);
	DED token * process(bool final=false);

 bbaserst * rst;
	EVALCBV evalcbv;
 EVALCBF evalcbf;
 static EVALCBF evalf2;
 static EVALCBV evalv2;
 //int lastpos,toplevelands;
	void * evalcbval;
	static unsigned char pre[256];
 SPtrArray tks,used;
 SArray<token *> tokens;
 //Stack<token *> tokens;
	DED signed char eval(const char * e,const char **err=0,bool append=false);
 DED void eval4(const char * e,const char **err=0);
 DED void eval2(const char * e,const char **err=0);
 DED void eval3(const char * e,const char **err=0);
 DED int getands(SDWordArray & apos,SDWordArray & asizes2,int pos);
 DED void freetoken(token * t);
 DED token * gettoken(char ** e,bool & fatalerror);
 DED void evalf(token * f,Stack<token*> & st,token * nnew);
 void Eval::tokenize(SD & sd);
 DED void Eval::dump();
 DED bool resolveV(Stack<token*> &st);
 DED bool Eval::resolveV(token** t);
 token * Eval::findvariable(SD & sd,long pos,bool & after,bool mmove);
 long sid; //for use with INDIRECT sWorkbook::evalf.....
 DED token * Eval::resolveV(token* t);
 DED void vwrap(token * f,Stack<token*> & st,token * nnew);
 bool in,noskipfill;
	DED void clear();
 DED void clearsub();
	DED Eval();
	DED ~Eval();
};

class Jit {
public:
 long actualsize,totalsize;
 unsigned char * buf;
 Jit();
 struct Anchor {
  unsigned long id;
  long pos;
  char type;
 };
 //enum {
 //}
 void mov_al(unsigned char c); //mov al,n
 void ret(unsigned short n); //ret n
 void int3(); //int 3
 void Flush();
 void mov_eax_dwordptr_esp(unsigned char n); //mov eax,[esp+n]
 void mov_ebx_dwordptr_esp(unsigned char n); //mov ebx,[esp+n]
 void mov_esi_dwordptr_esp(unsigned char n); //mov esi,[esp+n]
 void mov_edi_dwordptr_esp(unsigned char n); //mov edi,[esp+n]
 void Jit::mov_ecx_dwordptr_esi(); //mov ecx,[esi]
 void Jit::cmp_ecx_dwordptr_edi(); //cmp ecx,[edi]
 void Jit::movsx_ecx_wordptr_esi(); //movsx ecx,word ptr [esi]
 void Jit::movsx_eax_wordptr_edi(); //movsx eax,word ptr [edi]
 void Jit::add_esi(unsigned char n); //add esi,n
 void Jit::add_edi(unsigned char n); //add edi,n
 void Jit::cmp_ecx_eax(); //cmp ecx,eax
 void Jit::mov_ecx_dwordptr(unsigned long n); //mov ecx,[n]
 void Jit::movsx_ecx_wordptr(unsigned long n); //movsx ecx,word ptr [n]
 void Jit::movsx_ecx_byteptr(unsigned long n); //movsx ecx,byte ptr [n]
 void Jit::fld_qwordptr(unsigned long n); //fld qword ptr [n]
 void Jit::fld_dwordptr(unsigned long n); //fld dword ptr [n]

 void Jit::mov_esi(unsigned long n); //mov esi,n
 void Jit::add_esi2(unsigned long n); //add esi,n
 void Jit::add_edi2(unsigned long n); //add edi,n
 void Jit::std(); //std
 void Jit::cld(); //cld
 void Jit::add_ebx(unsigned char n); //add ebx,n
 void Jit::add_eax(unsigned char n); //add eax,n
 void Jit::add_eax2(unsigned long n); //add eax,n
 void Jit::add_ebx2(unsigned long n); //add ebx,n
 void Jit::mov_ecx_dwordptr_eax(); //mov ecx,[eax]
 void Jit::cmp_ecx_dwordptr_ebx(); //cmp ecx,[ebx]
 void jne(unsigned char n,unsigned long anchorid); //je n
 void jnz(unsigned char n,unsigned long anchorid); //jz n
 
 void je(unsigned char n,unsigned long anchorid); //je n
 void jz(unsigned char n,unsigned long anchorid); //jz n
 void jg(unsigned char n,unsigned long anchorid); //jg n
 void jl(unsigned char n,unsigned long anchorid); //jl n
 void Jit::SetAnchor(unsigned long anchorid);
 void Jit::movsx_ecx_wordptr_eax(); //movsx ecx,word ptr [eax]
 void Jit::movsx_edx_wordptr_ebx(); //movsx edx,word ptr [ebx]
 void Jit::cmp_ecx_edx(); //cmp ecx,edx
 void Jit::fld_qwordptr_esi(); //fld qword ptr [esi]
 void Jit::fcomp_qwordptr_edi(); //fcomp qword ptr [edi]
 void Jit::fld_dwordptr_esi(); //fld qword ptr [esi]
 void Jit::fcomp_dwordptr_edi(); //fcomp qword ptr [edi]
 
 void Jit::fld_qwordptr_eax(); //fld qword ptr [eax]
 void Jit::fcomp_qwordptr_ebx(); //fcomp qword ptr [ebx]
 void Jit::fld_dwordptr_eax(); //fld qword ptr [eax]
 void Jit::fcomp_dwordptr_ebx(); //fcomp qword ptr [ebx]
 void Jit::movsx_ecx_byteptr_eax(); //movsx ecx,byte ptr [eax]
 void Jit::movsx_edx_byteptr_ebx(); //movsx edx,byte ptr [ebx]
 void Jit::movsx_ecx_byteptr_esi(); //movsx ecx,byte ptr [esi]
 void Jit::movsx_eax_byteptr_edi(); //movsx eax,byte ptr [edi]
 
 void Jit::mov_esi_eax(); //mov esi,eax
 void Jit::mov_edi_ebx(); //mov edi,ebx
 void Jit::mov_ecx(unsigned long n); //mov ecx,n
 void Jit::mov_eax(unsigned long n); //mov eax,n
 void Jit::mov_ebx(unsigned long n); //mov ebx,n
 void Jit::pusha();
 void Jit::popa();
 void Jit::push_eax();
 void Jit::push_ebx();
 void Jit::push_ecx();
 void Jit::push_edx();
 void Jit::push_esi();
 void Jit::push_edi();

 void Jit::pop_eax();
 void Jit::pop_ebx();
 void Jit::pop_ecx();
 void Jit::pop_edx();
 void Jit::pop_esi();
 void Jit::pop_edi();
 void Jit::fnstsw_ax(); //fnstsw ax
 void Jit::test_ah(unsigned char n); //test ah,n

 void Jit::repe_cmps_dwordptr_esi_dwordptr_edi(); //repe cmps dword ptr [esi],dword ptr [edi]
 void Jit::repe_cmps_wordptr_esi_wordptr_edi(); //repe cmps word ptr [esi],word ptr [edi]
 void Jit::repe_cmps_byteptr_esi_byteptr_edi(); //repe cmps byte ptr [esi],byte ptr [edi]
 SArray<Anchor> anchors;
 ~Jit();
 
};
bool GetProxy(SD & pname,unsigned short & pport);

struct samest {
 long level,spos,epos; //>=1
 bool sset,eset;
 short sdir,edir;
 //char sdir[3];
 StringData sd,ed;  //value >=ssd && value<=eed
 //StringData ed;
 bool operator >=(samest& s) {
  return level>=s.level;
 }
 bool operator ==(long l) {
  return level==l;
 }
 bool operator <(long l) {
  return level<l;
 }
 void operator =(samest& s) {
  level=s.level;
  sset=s.sset;
  eset=s.eset;
  sd=s.sd;
  ed=s.ed;
  spos=s.spos;
  epos=s.epos;
  sdir=s.sdir;
  edir=s.edir;
  //memcpy(sdir,s.sdir,3);
  //eq=s.eq;
  //ed=s.ed;
 }
 samest() {
  //eq=false;
  spos=-1;
  epos=-1;
  level=-1;
  sset=false;
  eset=false;
 }
};

struct PWhere {
 SDWordArray trueskip,falseskip;
 Eval ev;
 bool useeval,prefereval;
 int nw;
 bbaserst * rst;
 StringDataArray wheresds;
 SPtrArray wc;
 SByteArray wdts,islike;
 SDWordArray wfpos;
 StringData sd;
 SD errorstr;
 SArray2<samest> samests;
 StringDataArray seeksds;
 int lastx;
 signed char lastc;
 void inext();
 void iprev();
 bool set(const char * ssql,bbaserst * r,bool iset=false);
 bool isok(bbaserst * r=0);
 void clear();
 PWhere();
 ~PWhere();
};

#endif
