#ifndef RT_INCLUDED
#define RT_INCLUDED
#include "utils2.h"
#include "eval.h"
#include "baserst.h"
#include "bsort5.h"
#include "ecommon.h"
#include "sfile11.h"
#include "rst.h"

class TempTable;
typedef bool (* SQLCB2) (TempTable * r);
//typedef BSort5 BSORT;
class TempTable :public bbaserst{
 friend class TempTableRst;
public:
 baserst * parent; //setted by grid
 bbaserst * getparent();
 void TempTable::restbookmark(BookMark *bm);
 BookMark * TempTable::savebookmark();
 //bbaserst * parent; //for internal use only ...
 TempTableRst * bounce; //for internal use only ...
 DED void Setdb(IDatabase * db);
 DED void operator =(IDatabase & db);
 DED void operator =(IDatabase * db);
 DED signed long getfpos3(const char *fn);
 DED long GetAbsolutePosition();
 DED static SPtrArray ary;
 DED bool IsDeleted();
 DED void setdeleted(bool b);
 DED StringData getjname(signed long jpos);
 DED signed long getjpos(signed long fpos);
 DED signed long getfpos(const char *fn);
 DED signed long getfpos2(const char *fn,bool eval=false);
 DED unsigned char GetFieldType(signed long pos);
 DED unsigned char GetFieldType(const char * fn);
 DED long GetMaxSize(signed long pos);
 DED long TempTable::GetRecordCount();
 DED long GetFieldCount(Join * upto=0);
 DED long GetFieldCount2();
 DED void addfields(baserst * r);
 DED bool Find(const char * ssql,char dir,SD repsrc=SD(),bool repformula=false,signed long repdestfid=-1,Grid * grid=0,TBox * gridctrl=0);
 DED void RenameField(const char *old,const char * nnew);
 DED unsigned char getdt(const char *fn);
 DED void addfield(const char * name,unsigned char dt,long maxsize=0);
 DED void addfield2(const char * name,unsigned char dt,long maxsize=0);
 DED void addfield3(const char * name,unsigned char dt,long maxsize);
 DED void addfield4(const char * name,unsigned char dt,long maxsize);
 DED void openrstz2(unsigned long top,unsigned long first,Eval * ev,EVALJoin & ej,const char *tablename,const char *indexname,SDWordArray & orderby,bool distinct,SDWordArray & distincts,TempTableRst * rst);
 TableDef td;
 DED TempTable();
 DED ~TempTable();
 DED void Create();
 DED void init();
 DED void Close();
 SFile3 rf,sf1; //records file, string file
 //SDWordArray deleted;
 DED void AddNew();
 DED StringData GetFieldName(signed long pos);
 DED void SetFieldValue(signed long pos,const StringData & sd);
 DED void SetFieldValue(const char *fn,const StringData & sd);
 //unsigned char getid(const char *fn);
 DED void Update();
 DED void append();
 DED void Edit();
 DED void edit();
 DED void CancelUpdate();
 DED void MoveFirst();
 DED void MoveLast();
 DED void MoveNext();
 DED void MovePrev();
 DED bool IsEOF();
 DED void getnullfield(signed long pos,StringData & sd);
 DED bool IsBOF();
 DED void Zap();
 DED void Delete();
 DED StringData & GetFieldValue3(signed long pos,StringData &sd);
 DED StringData& GetFieldValue3(const char * fn,StringData & sd);
 DED StringData GetFieldValue3(const char * fn);
 DED StringData GetFieldValue3(signed long fpos);

 DED StringData & GetFieldValue(signed long pos,StringData &sd);
 DED StringData& GetFieldValue(const char * fn,StringData & sd);
 DED StringData GetFieldValue(const char * fn);
 DED StringData GetFieldValue(signed long fpos);
 DED void TempTable::Copy(TempTableRst * r);
 //DED void GetFieldValue(const char * fn,StringData & sd);
 DED bool IsOpen();
 SQLCB2 sqlcb;
 long curpos;
 char lastea;
 DED void removejoin(Join * j);
 DED void setjoin(Join * j);
 int recordlen;
 SPtrArray ff;
private:
 DED void clearff();
 //DED void fetchstringfixed(char * rec,long pos,long maxsize);
 //DED void fetchstring(StringData * sd,long pos,TableDef::Field*f);
 //DED signed char cmpia(SPtrArray * ra,SPtrArray *va,SDWordArray *nids,SByteArray & desc,unsigned char level);
 //DED void setia(SPtrArray * ra,SDWordArray * nids);
 //DED void clearia(SPtrArray * ra,SDWordArray *nids);
 //DED void fillia(SPtrArray * ra,SDWordArray *nids,long base,unsigned char level);
 //long autonum;
 unsigned char * zerobuf;

 DED void clearfda();
 //SPtrArray join;
};

class TempTableRst : public baserst {
 friend class TempTable;
private:
 //void TempTableRst::fillrec2sd(StringData * sd,unsigned char n);
 void fillrecsd(StringData * sd,long n);
 static signed char CALLBACK bsortcb6(char * rec,char * ia,SD *sds,TempTableRst * rst,long covered);
 
 bool curposdeleted; //,bookmarkdel;
 void sortedinsert(bool append);
 //SByteArray desc,odts; //orderby ids
 //SDWordArray omaxsize,oids;
 
 void Resort(const char * orderby);
 struct BS4 {
  int seeklevel;
  SByteArray desc,odts;
  SDWordArray omaxsize,oids;
  SDA osda;
  StringData sd; //used in bsortcb6
  //long keyscovered;
  void clear() {
   desc.RemoveAll();
   odts.RemoveAll();
   omaxsize.RemoveAll();
   oids.RemoveAll();
  }
 } bs4;
 
 bool opened;
 //void fillirec(char * rec);
 //void update2();
public:
 long _ttpos(); //used by grid double click
 DED static SPtrArray ary;
 signed long getfpos3(const char * fn);
 bool Seek(const char * d,StringDataArray & sd);
 bool Seek(const char * d,StringData *sd,unsigned char n);
 void setjoin(Join * j);
 
 DED long GetMaxSize(signed long pos);
 BSORT sort;
 DED long GetFieldCount(Join * upto=0);
 DED long GetFieldCount2();
 SD ssql;
 void Zap();
 void setbm(signed long bm);
 signed long getbm();
 bool Find(const char * ssql,char dir,SD repsrc=SD(),bool repformula=false,signed long repdestfid=-1,Grid * grid=0,TBox * gridctrl=0);
 DED StringData getjname(signed long jpos);
 DED signed long getjpos(signed long fpos);
 DED signed long getfpos(const char * fn);
 DED signed long getfpos2(const char * fn,bool eval=false);
 DED void harddelete(unsigned long pos1,unsigned long pos2,signed long TOTFPOS);
 DED void softdelete(unsigned long pos1,unsigned long pos2); //,signed long TOTFPOS);
 void softappend();
 DED void Insert();
 DED void Insert2();
 //TempTable * rt;
 //signed long *posmap;
 //long posmapsize;
 DED void softdelete();
 void newrt();
 DED void buildposmap();
 DED short GetEditMode();
 DED long GetRecordCount();
 DED long GetAbsolutePosition();
 DED void SetAbsolutePosition(signed long pos);
 DED void requery();
 DED char gettype();
 DED void deletee();
 BookMark * savebookmark();
 DED void restbookmark(BookMark *bm);
 DED void deletebookmark(BookMark *bm);
 DED void movefirst();
 DED void movelast();
 DED void movenext();
 DED void moveprev();
 DED void move(int n);
 DED bool iseof();
 DED bool isbof();
 DED StringData getfieldstr(const char * fn);
 DED StringData GetFieldName(signed long pos);
 DED SD GetCurrentIndex();
 DED void SetCurrentIndex(const char * index);
 DED bool IsDeleted();
 DED void setdeleted(bool b);
 DED unsigned char GetFieldType(const char * fn);
 DED unsigned char GetFieldType(signed long pos);
 DED void CancelUpdate();
 //DED SHORT Getfieldtype(const char * fn);
 DED void AddNew();
 DED void SetFieldValue(signed long pos,const StringData & sd);
 DED void SetFieldValue(const char * fn,StringData & sd);
 DED void Update();
 DED bool IsEOF();
 DED bool IsBOF();
 DED void MovePrev();
 DED void MoveNext();
 DED StringData GetFieldValue3(signed long fpos);
 DED StringData GetFieldValue3(const char *fn);
 DED StringData & GetFieldValue3(const char *fn,StringData &sd);
 DED StringData & GetFieldValue3(signed long pos,StringData &sd);

 DED StringData GetFieldValue(signed long fpos);
 DED StringData GetFieldValue(const char *fn);
 DED StringData & GetFieldValue(const char *fn,StringData &sd);
 DED StringData & GetFieldValue(signed long pos,StringData &sd);
 DED void updatesub();

 TempTable * tb;
 bool showadditions,autosort;
 DED void fillrec(char * rec); //,long keyscovered);
 DED bool haskey();
 DED void MoveFirst();
 DED void MoveLast();
 DED void Edit();
 DED void Delete();
 DED bool Open(const char * sql);
 //DED bool open2(const char * sql);
 DED bool IsOpen();
 DED void Close();
 IDatabase * stpdb;
 SPtrArray bookmarks;
 bool istotal();
 void deletetotal(); //special called from grid only..
 DED TempTableRst();
 DED ~TempTableRst();
private:
 //signed _int64 bookmarkpos;
 //long lastseekmid;
};
DED void fill(TempTable & rdet);
DED void tabtort(StringData & buf,TempTable & rt,bool makeupper);



class RamTable :public bbaserst{

public:
 struct Field {
  SD name;
  unsigned char dt;
  long maxsize;
  long pos;
  void operator=(Field & f) {
   tthrow("error");
  }
  Field() {
  }
  Field(Field & f) {
   tthrow("error");
  }
 };
 bool Find(const char * ssql,char dir,SD repsrc=SD(),bool repformula=false,signed long repdestfid=-1,Grid * grid=0,TBox * gridctrl=0) {
  tthrow("not implemented");
  return false;
 }
 SArray2<Field> fields;
 bool created;
 //long sffilesize;
 SFile3 sf;
 //File sf;
 SArray<bool> desc;
 inline bool Seek2(short d,long n) {//ASSUMES bsort.rec is already filled ....
  ASSERT(n<=seeklevel);
  bsort.cbb=(void *)n;
  return bsort.seek(d);
 }
 DED bool Seek(const char * d,StringData * sd,long n);
 DED void Edit();
 DED void AddNew();
 char lastea;
 long fdasize,seeklevel;
 DED void fillrecsd(StringData * sd,long n);
 DED unsigned char GetFieldType(signed long pos);
 DED static signed char CALLBACK bsortcb(char * rec,char * ia,RamTable * rst,long seeklevel,void * c);
 DED static signed char CALLBACK bsortcbexcel(char * rec,char * ia,RamTable * rst,long seeklevel,void * c);
 DED signed long getfpos(const char *fn);
 DED signed long getfpos2(const char *fn,bool b=false);
 DED signed long getfpos3(const char *fn);
 DED inline bool IsOpen() {return created;}
 DED void AddField(const char * name,unsigned char dt,long maxsize=0);
 void RamTable::Create(int seeklevel,bool * desc=0);
 DED long GetFieldCount(Join * upto=0);
 DED long GetFieldCount2();
 DED unsigned char GetFieldType(const char * fn);
 DED StringData GetFieldValue(const char * fn);
 DED void SetFieldValue(signed long pos,const StringData & sd);
 DED StringData GetFieldValue(signed long pos);
 StringData & GetFieldValuezz(signed long pos,StringData &sd);
 DED StringData & GetFieldValue(signed long pos,StringData &sd);
 DED StringData & GetFieldValue(const char * fn,StringData &sd);
 bool lowram;
 inline bool IsEOF() {return bsort.iseof();}
 inline bool IsBOF() {return bsort.isbof();}
 DED void RamTable::MoveLast();
 DED void RamTable::MoveFirst();
 DED void RamTable::Delete();
 DED long GetAbsolutePosition();
 DED StringData RamTable::GetFieldName(signed long pos);
 DED void RamTable::Zap();
 DED void RamTable::MovePrev();
 DED void RamTable::MoveNext();

 DED void RamTable::updatesub(char * rec);
 DED void RamTable::updatesubzz(char * rec);
 DED long RamTable::GetMaxSize(signed long pos);
 DED bool RamTable::haskey();
 DED void RamTable::CancelUpdate();
 DED long GetRecordCount() {return bsort.getcount();}

 void Update();
 SArray2<TempTable::Fielddata> fda;
 BSort5 bsort;
 RamTable() {
  created=false;
  fdasize=0;
  lastea=0;
 }
};

#endif
